## This concern has +like+, +unlike+ controller actions
## When you use it, be sure that +set_sociable+ method is implemented in your controller, otherwise an fatal error will raise.
module SociableController
  extend ActiveSupport::Concern

  included do
    before_action :authenticate_user!, only: [:like, :unlike]
    before_action :view_object!, only: viewable_methods
  end

  # POST /v1/learning_objects/1/like
  # POST /v1/learning_objects/1/like.json
  def like
    if !sociable.liked? current_user
      sociable.like current_user
      render json: {count: sociable.likes.count}, status: :created
    else
      render nothing: true, status: :forbidden
    end
  end

  # DELETE /v1/learning_objects/1/unlike
  # DELETE /v1/learning_objects/1/unlike.json
  def unlike
    if sociable.liked? current_user
      sociable.dislike current_user
      render json: {count: sociable.likes.count}, status: :ok
    else
      render nothing: true, status: :forbidden
    end
  end

  # POST /v1/learning_objects/1/like
  # POST /v1/learning_objects/1/like.json
  def like
    if !sociable.liked? current_user
      sociable.like current_user
      render json: {count: sociable.likes.count}, status: :created
    else
      render nothing: true, status: :forbidden
    end
  end

  protected

  def view_object!
    sociable.view current_user if user_signed_in?
  end

  def viewable_methods
    [:show]
  end

end