Rails.application.routes.draw do
  devise_for :users
  require 'sidekiq/web'

  concern :followable do
    member do
      post :follow
      delete :unfollow
    end
  end

  # devise_for :users, :controllers => { :omniauth_callbacks => "callbacks" }
  namespace :v1 do
    mount_devise_token_auth_for 'User', skip: [:omniauth_callbacks], at: :auth

    resources :users, concerns: :followable
    resources :collections, concerns: :followable
  end

end
