require 'test_helper'

class CollectionTest < ActiveSupport::TestCase
  should have_many :collection_items
  should have_many(:collections).through(:collection_items).source(:collectionable)
  should have_many(:learning_objects).through(:collection_items).source(:collectionable)

  should belong_to :owner

  should validate_presence_of(:name)
  should validate_presence_of(:owner)
  should validate_inclusion_of(:privacy).in_array(%w(public private)).with_message('Privacy must be public or private')
end
